//#line 2 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the jsk_pcl_ros package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __jsk_pcl_ros__ICPREGISTRATIONCONFIG_H__
#define __jsk_pcl_ros__ICPREGISTRATIONCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace jsk_pcl_ros
{
  class ICPRegistrationConfigStatics;

  class ICPRegistrationConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(ICPRegistrationConfig &config, const ICPRegistrationConfig &max, const ICPRegistrationConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ICPRegistrationConfig &config1, const ICPRegistrationConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ICPRegistrationConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ICPRegistrationConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ICPRegistrationConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ICPRegistrationConfig &config) const = 0;
      virtual void getValue(const ICPRegistrationConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T ICPRegistrationConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T (ICPRegistrationConfig::* field);

      virtual void clamp(ICPRegistrationConfig &config, const ICPRegistrationConfig &max, const ICPRegistrationConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ICPRegistrationConfig &config1, const ICPRegistrationConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ICPRegistrationConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ICPRegistrationConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ICPRegistrationConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ICPRegistrationConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const ICPRegistrationConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, ICPRegistrationConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, ICPRegistrationConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<ICPRegistrationConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(ICPRegistrationConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("algorithm"==(*_i)->name){algorithm = boost::any_cast<int>(val);}
        if("correspondence_algorithm"==(*_i)->name){correspondence_algorithm = boost::any_cast<int>(val);}
        if("use_flipped_initial_pose"==(*_i)->name){use_flipped_initial_pose = boost::any_cast<bool>(val);}
        if("max_iteration"==(*_i)->name){max_iteration = boost::any_cast<int>(val);}
        if("correspondence_distance"==(*_i)->name){correspondence_distance = boost::any_cast<double>(val);}
        if("transform_epsilon"==(*_i)->name){transform_epsilon = boost::any_cast<double>(val);}
        if("euclidean_fittness_epsilon"==(*_i)->name){euclidean_fittness_epsilon = boost::any_cast<double>(val);}
        if("rotation_epsilon"==(*_i)->name){rotation_epsilon = boost::any_cast<double>(val);}
        if("ransac_iterations"==(*_i)->name){ransac_iterations = boost::any_cast<int>(val);}
        if("ransac_outlier_threshold"==(*_i)->name){ransac_outlier_threshold = boost::any_cast<double>(val);}
        if("correspondence_randomness"==(*_i)->name){correspondence_randomness = boost::any_cast<int>(val);}
        if("maximum_optimizer_iterations"==(*_i)->name){maximum_optimizer_iterations = boost::any_cast<int>(val);}
        if("ndt_resolution"==(*_i)->name){ndt_resolution = boost::any_cast<double>(val);}
        if("ndt_step_size"==(*_i)->name){ndt_step_size = boost::any_cast<double>(val);}
        if("ndt_outlier_ratio"==(*_i)->name){ndt_outlier_ratio = boost::any_cast<double>(val);}
      }
    }

    int algorithm;
int correspondence_algorithm;
bool use_flipped_initial_pose;
int max_iteration;
double correspondence_distance;
double transform_epsilon;
double euclidean_fittness_epsilon;
double rotation_epsilon;
int ransac_iterations;
double ransac_outlier_threshold;
int correspondence_randomness;
int maximum_optimizer_iterations;
double ndt_resolution;
double ndt_step_size;
double ndt_outlier_ratio;

    bool state;
    std::string name;

    
}groups;



//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int algorithm;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int correspondence_algorithm;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool use_flipped_initial_pose;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int max_iteration;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double correspondence_distance;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double transform_epsilon;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double euclidean_fittness_epsilon;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double rotation_epsilon;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int ransac_iterations;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double ransac_outlier_threshold;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int correspondence_randomness;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int maximum_optimizer_iterations;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double ndt_resolution;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double ndt_step_size;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double ndt_outlier_ratio;
//#line 228 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ICPRegistrationConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ICPRegistrationConfig &__max__ = __getMax__();
      const ICPRegistrationConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ICPRegistrationConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ICPRegistrationConfig &__getDefault__();
    static const ICPRegistrationConfig &__getMax__();
    static const ICPRegistrationConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const ICPRegistrationConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void ICPRegistrationConfig::ParamDescription<std::string>::clamp(ICPRegistrationConfig &config, const ICPRegistrationConfig &max, const ICPRegistrationConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class ICPRegistrationConfigStatics
  {
    friend class ICPRegistrationConfig;

    ICPRegistrationConfigStatics()
    {
ICPRegistrationConfig::GroupDescription<ICPRegistrationConfig::DEFAULT, ICPRegistrationConfig> Default("Default", "", 0, 0, true, &ICPRegistrationConfig::groups);
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.algorithm = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.algorithm = 2;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.algorithm = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("algorithm", "int", 0, "algorithm", "{'enum_description': 'algorithm', 'enum': [{'srcline': 11, 'description': 'ICP', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'ICP'}, {'srcline': 12, 'description': 'GICP', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'GICP'}, {'srcline': 13, 'description': 'NDT', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'NDT'}]}", &ICPRegistrationConfig::algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("algorithm", "int", 0, "algorithm", "{'enum_description': 'algorithm', 'enum': [{'srcline': 11, 'description': 'ICP', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'ICP'}, {'srcline': 12, 'description': 'GICP', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'GICP'}, {'srcline': 13, 'description': 'NDT', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'NDT'}]}", &ICPRegistrationConfig::algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.correspondence_algorithm = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.correspondence_algorithm = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.correspondence_algorithm = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("correspondence_algorithm", "int", 0, "correspondence_algorithm", "{'enum_description': 'correspondence_algorithm', 'enum': [{'srcline': 17, 'description': 'NN', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'NN'}, {'srcline': 18, 'description': 'Projective', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Projective'}]}", &ICPRegistrationConfig::correspondence_algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("correspondence_algorithm", "int", 0, "correspondence_algorithm", "{'enum_description': 'correspondence_algorithm', 'enum': [{'srcline': 17, 'description': 'NN', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'NN'}, {'srcline': 18, 'description': 'Projective', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Projective'}]}", &ICPRegistrationConfig::correspondence_algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.use_flipped_initial_pose = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.use_flipped_initial_pose = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.use_flipped_initial_pose = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<bool>("use_flipped_initial_pose", "bool", 0, "consider flipped initial pose", "", &ICPRegistrationConfig::use_flipped_initial_pose)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<bool>("use_flipped_initial_pose", "bool", 0, "consider flipped initial pose", "", &ICPRegistrationConfig::use_flipped_initial_pose)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.max_iteration = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.max_iteration = 10000;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.max_iteration = 100;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("max_iteration", "int", 0, "the maximum iteration", "", &ICPRegistrationConfig::max_iteration)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("max_iteration", "int", 0, "the maximum iteration", "", &ICPRegistrationConfig::max_iteration)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.correspondence_distance = 0.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.correspondence_distance = 100.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.correspondence_distance = 10.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("correspondence_distance", "double", 0, "distance to ignore to calculate correspondence", "", &ICPRegistrationConfig::correspondence_distance)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("correspondence_distance", "double", 0, "distance to ignore to calculate correspondence", "", &ICPRegistrationConfig::correspondence_distance)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.transform_epsilon = 1e-09;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.transform_epsilon = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.transform_epsilon = 1e-09;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("transform_epsilon", "double", 0, "transform epsion to stop iteration", "", &ICPRegistrationConfig::transform_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("transform_epsilon", "double", 0, "transform epsion to stop iteration", "", &ICPRegistrationConfig::transform_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.euclidean_fittness_epsilon = 0.0001;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.euclidean_fittness_epsilon = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.euclidean_fittness_epsilon = 0.01;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("euclidean_fittness_epsilon", "double", 0, "euclidean fittness epsilon", "", &ICPRegistrationConfig::euclidean_fittness_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("euclidean_fittness_epsilon", "double", 0, "euclidean fittness epsilon", "", &ICPRegistrationConfig::euclidean_fittness_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.rotation_epsilon = 1e-09;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.rotation_epsilon = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.rotation_epsilon = 0.002;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("rotation_epsilon", "double", 0, "rotation epsilon (only for GICP)", "", &ICPRegistrationConfig::rotation_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("rotation_epsilon", "double", 0, "rotation epsilon (only for GICP)", "", &ICPRegistrationConfig::rotation_epsilon)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ransac_iterations = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ransac_iterations = 10000;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ransac_iterations = 1000;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("ransac_iterations", "int", 0, "ransac iterations", "", &ICPRegistrationConfig::ransac_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("ransac_iterations", "int", 0, "ransac iterations", "", &ICPRegistrationConfig::ransac_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ransac_outlier_threshold = 0.01;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ransac_outlier_threshold = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ransac_outlier_threshold = 0.05;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ransac_outlier_threshold", "double", 0, "ransac outlier threshold", "", &ICPRegistrationConfig::ransac_outlier_threshold)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ransac_outlier_threshold", "double", 0, "ransac outlier threshold", "", &ICPRegistrationConfig::ransac_outlier_threshold)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.correspondence_randomness = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.correspondence_randomness = 100;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.correspondence_randomness = 20;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("correspondence_randomness", "int", 0, "correspondence randomness (only for GICP)", "", &ICPRegistrationConfig::correspondence_randomness)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("correspondence_randomness", "int", 0, "correspondence randomness (only for GICP)", "", &ICPRegistrationConfig::correspondence_randomness)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.maximum_optimizer_iterations = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.maximum_optimizer_iterations = 100;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.maximum_optimizer_iterations = 20;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("maximum_optimizer_iterations", "int", 0, "maximum optimizer iterations (only for GICP)", "", &ICPRegistrationConfig::maximum_optimizer_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<int>("maximum_optimizer_iterations", "int", 0, "maximum optimizer iterations (only for GICP)", "", &ICPRegistrationConfig::maximum_optimizer_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ndt_resolution = 1e-06;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ndt_resolution = 10.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ndt_resolution = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_resolution", "double", 0, "", "", &ICPRegistrationConfig::ndt_resolution)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_resolution", "double", 0, "", "", &ICPRegistrationConfig::ndt_resolution)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ndt_step_size = 1e-06;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ndt_step_size = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ndt_step_size = 0.05;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_step_size", "double", 0, "", "", &ICPRegistrationConfig::ndt_step_size)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_step_size", "double", 0, "", "", &ICPRegistrationConfig::ndt_step_size)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.ndt_outlier_ratio = 1e-06;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.ndt_outlier_ratio = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.ndt_outlier_ratio = 0.35;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_outlier_ratio", "double", 0, "", "", &ICPRegistrationConfig::ndt_outlier_ratio)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(ICPRegistrationConfig::AbstractParamDescriptionConstPtr(new ICPRegistrationConfig::ParamDescription<double>("ndt_outlier_ratio", "double", 0, "", "", &ICPRegistrationConfig::ndt_outlier_ratio)));
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(ICPRegistrationConfig::AbstractGroupDescriptionConstPtr(new ICPRegistrationConfig::GroupDescription<ICPRegistrationConfig::DEFAULT, ICPRegistrationConfig>(Default)));
//#line 366 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<ICPRegistrationConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<ICPRegistrationConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<ICPRegistrationConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    ICPRegistrationConfig __max__;
    ICPRegistrationConfig __min__;
    ICPRegistrationConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const ICPRegistrationConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ICPRegistrationConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ICPRegistrationConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const ICPRegistrationConfig &ICPRegistrationConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const ICPRegistrationConfig &ICPRegistrationConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const ICPRegistrationConfig &ICPRegistrationConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<ICPRegistrationConfig::AbstractParamDescriptionConstPtr> &ICPRegistrationConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<ICPRegistrationConfig::AbstractGroupDescriptionConstPtr> &ICPRegistrationConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const ICPRegistrationConfigStatics *ICPRegistrationConfig::__get_statics__()
  {
    const static ICPRegistrationConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ICPRegistrationConfigStatics::get_instance();

    return statics;
  }

//#line 11 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg"
      const int ICPRegistration_ICP = 0;
//#line 12 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg"
      const int ICPRegistration_GICP = 1;
//#line 13 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg"
      const int ICPRegistration_NDT = 2;
//#line 17 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg"
      const int ICPRegistration_NN = 0;
//#line 18 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/ICPRegistration.cfg"
      const int ICPRegistration_Projective = 1;
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __ICPREGISTRATIONRECONFIGURATOR_H__
