//#line 2 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"
// *********************************************************
//
// File autogenerated for the jsk_pcl_ros package
// by the dynamic_reconfigure package.
// Please do not edit.
//
// ********************************************************/

#ifndef __jsk_pcl_ros__TORUSFINDERCONFIG_H__
#define __jsk_pcl_ros__TORUSFINDERCONFIG_H__

#if __cplusplus >= 201103L
#define DYNAMIC_RECONFIGURE_FINAL final
#else
#define DYNAMIC_RECONFIGURE_FINAL
#endif

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/Group.h>
#include <dynamic_reconfigure/config_init_mutex.h>
#include <boost/any.hpp>

namespace jsk_pcl_ros
{
  class TorusFinderConfigStatics;

  class TorusFinderConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l,
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }

      virtual void clamp(TorusFinderConfig &config, const TorusFinderConfig &max, const TorusFinderConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const TorusFinderConfig &config1, const TorusFinderConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, TorusFinderConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const TorusFinderConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TorusFinderConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const TorusFinderConfig &config) const = 0;
      virtual void getValue(const TorusFinderConfig &config, boost::any &val) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template <class T>
    class ParamDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string a_name, std::string a_type, uint32_t a_level,
          std::string a_description, std::string a_edit_method, T TorusFinderConfig::* a_f) :
        AbstractParamDescription(a_name, a_type, a_level, a_description, a_edit_method),
        field(a_f)
      {}

      T (TorusFinderConfig::* field);

      virtual void clamp(TorusFinderConfig &config, const TorusFinderConfig &max, const TorusFinderConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;

        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const TorusFinderConfig &config1, const TorusFinderConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, TorusFinderConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const TorusFinderConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, TorusFinderConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const TorusFinderConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }

      virtual void getValue(const TorusFinderConfig &config, boost::any &val) const
      {
        val = config.*field;
      }
    };

    class AbstractGroupDescription : public dynamic_reconfigure::Group
    {
      public:
      AbstractGroupDescription(std::string n, std::string t, int p, int i, bool s)
      {
        name = n;
        type = t;
        parent = p;
        state = s;
        id = i;
      }

      std::vector<AbstractParamDescriptionConstPtr> abstract_parameters;
      bool state;

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &config) const =0;
      virtual void updateParams(boost::any &cfg, TorusFinderConfig &top) const= 0;
      virtual void setInitialState(boost::any &cfg) const = 0;


      void convertParams()
      {
        for(std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = abstract_parameters.begin(); i != abstract_parameters.end(); ++i)
        {
          parameters.push_back(dynamic_reconfigure::ParamDescription(**i));
        }
      }
    };

    typedef boost::shared_ptr<AbstractGroupDescription> AbstractGroupDescriptionPtr;
    typedef boost::shared_ptr<const AbstractGroupDescription> AbstractGroupDescriptionConstPtr;

    // Final keyword added to class because it has virtual methods and inherits
    // from a class with a non-virtual destructor.
    template<class T, class PT>
    class GroupDescription DYNAMIC_RECONFIGURE_FINAL : public AbstractGroupDescription
    {
    public:
      GroupDescription(std::string a_name, std::string a_type, int a_parent, int a_id, bool a_s, T PT::* a_f) : AbstractGroupDescription(a_name, a_type, a_parent, a_id, a_s), field(a_f)
      {
      }

      GroupDescription(const GroupDescription<T, PT>& g): AbstractGroupDescription(g.name, g.type, g.parent, g.id, g.state), field(g.field), groups(g.groups)
      {
        parameters = g.parameters;
        abstract_parameters = g.abstract_parameters;
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        if(!dynamic_reconfigure::ConfigTools::getGroupState(msg, name, (*config).*field))
          return false;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          if(!(*i)->fromMessage(msg, n))
            return false;
        }

        return true;
      }

      virtual void setInitialState(boost::any &cfg) const
      {
        PT* config = boost::any_cast<PT*>(cfg);
        T* group = &((*config).*field);
        group->state = state;

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = boost::any(&((*config).*field));
          (*i)->setInitialState(n);
        }

      }

      virtual void updateParams(boost::any &cfg, TorusFinderConfig &top) const
      {
        PT* config = boost::any_cast<PT*>(cfg);

        T* f = &((*config).*field);
        f->setParams(top, abstract_parameters);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          boost::any n = &((*config).*field);
          (*i)->updateParams(n, top);
        }
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const boost::any &cfg) const
      {
        const PT config = boost::any_cast<PT>(cfg);
        dynamic_reconfigure::ConfigTools::appendGroup<T>(msg, name, id, parent, config.*field);

        for(std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = groups.begin(); i != groups.end(); ++i)
        {
          (*i)->toMessage(msg, config.*field);
        }
      }

      T (PT::* field);
      std::vector<TorusFinderConfig::AbstractGroupDescriptionConstPtr> groups;
    };

class DEFAULT
{
  public:
    DEFAULT()
    {
      state = true;
      name = "Default";
    }

    void setParams(TorusFinderConfig &config, const std::vector<AbstractParamDescriptionConstPtr> params)
    {
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator _i = params.begin(); _i != params.end(); ++_i)
      {
        boost::any val;
        (*_i)->getValue(config, val);

        if("algorithm"==(*_i)->name){algorithm = boost::any_cast<std::string>(val);}
        if("min_radius"==(*_i)->name){min_radius = boost::any_cast<double>(val);}
        if("max_radius"==(*_i)->name){max_radius = boost::any_cast<double>(val);}
        if("outlier_threshold"==(*_i)->name){outlier_threshold = boost::any_cast<double>(val);}
        if("max_iterations"==(*_i)->name){max_iterations = boost::any_cast<int>(val);}
        if("min_size"==(*_i)->name){min_size = boost::any_cast<int>(val);}
        if("eps_hint_angle"==(*_i)->name){eps_hint_angle = boost::any_cast<double>(val);}
        if("voxel_grid_sampling"==(*_i)->name){voxel_grid_sampling = boost::any_cast<bool>(val);}
        if("voxel_size"==(*_i)->name){voxel_size = boost::any_cast<double>(val);}
      }
    }

    std::string algorithm;
double min_radius;
double max_radius;
double outlier_threshold;
int max_iterations;
int min_size;
double eps_hint_angle;
bool voxel_grid_sampling;
double voxel_size;

    bool state;
    std::string name;

    
}groups;



//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      std::string algorithm;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double min_radius;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double max_radius;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double outlier_threshold;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int max_iterations;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      int min_size;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double eps_hint_angle;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      bool voxel_grid_sampling;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      double voxel_size;
//#line 228 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();

      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        if ((*i)->fromMessage(msg, *this))
          count++;

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i ++)
      {
        if ((*i)->id == 0)
        {
          boost::any n = boost::any(this);
          (*i)->updateParams(n, *this);
          (*i)->fromMessage(msg, n);
        }
      }

      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("TorusFinderConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__, const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toMessage(msg, *this);

      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        if((*i)->id == 0)
        {
          (*i)->toMessage(msg, *this);
        }
      }
    }

    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      __toMessage__(msg, __param_descriptions__, __group_descriptions__);
    }

    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      static bool setup=false;

      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->fromServer(nh, *this);

      const std::vector<AbstractGroupDescriptionConstPtr> &__group_descriptions__ = __getGroupDescriptions__();
      for (std::vector<AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); i++){
        if (!setup && (*i)->id == 0) {
          setup = true;
          boost::any n = boost::any(this);
          (*i)->setInitialState(n);
        }
      }
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const TorusFinderConfig &__max__ = __getMax__();
      const TorusFinderConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const TorusFinderConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); ++i)
        (*i)->calcLevel(level, config, *this);
      return level;
    }

    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const TorusFinderConfig &__getDefault__();
    static const TorusFinderConfig &__getMax__();
    static const TorusFinderConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    static const std::vector<AbstractGroupDescriptionConstPtr> &__getGroupDescriptions__();

  private:
    static const TorusFinderConfigStatics *__get_statics__();
  };

  template <> // Max and min are ignored for strings.
  inline void TorusFinderConfig::ParamDescription<std::string>::clamp(TorusFinderConfig &config, const TorusFinderConfig &max, const TorusFinderConfig &min) const
  {
    (void) config;
    (void) min;
    (void) max;
    return;
  }

  class TorusFinderConfigStatics
  {
    friend class TorusFinderConfig;

    TorusFinderConfigStatics()
    {
TorusFinderConfig::GroupDescription<TorusFinderConfig::DEFAULT, TorusFinderConfig> Default("Default", "", 0, 0, true, &TorusFinderConfig::groups);
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.algorithm = "";
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.algorithm = "";
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.algorithm = "RANSAC";
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<std::string>("algorithm", "str", 0, "algorithm to estimate model", "{'enum_description': 'Available Algorithmes', 'enum': [{'srcline': 12, 'description': 'RANSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RANSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RANSAC'}, {'srcline': 13, 'description': 'LMEDS', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'LMEDS', 'ctype': 'std::string', 'type': 'str', 'name': 'LMEDS'}, {'srcline': 14, 'description': 'MSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'MSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'MSAC'}, {'srcline': 15, 'description': 'RRANSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RRANSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RRANSAC'}, {'srcline': 16, 'description': 'RMSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RMSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RMSAC'}, {'srcline': 17, 'description': 'MLESAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'MLESAC', 'ctype': 'std::string', 'type': 'str', 'name': 'MLESAC'}, {'srcline': 18, 'description': 'PROSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'PROSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'PROSAC'}]}", &TorusFinderConfig::algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<std::string>("algorithm", "str", 0, "algorithm to estimate model", "{'enum_description': 'Available Algorithmes', 'enum': [{'srcline': 12, 'description': 'RANSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RANSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RANSAC'}, {'srcline': 13, 'description': 'LMEDS', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'LMEDS', 'ctype': 'std::string', 'type': 'str', 'name': 'LMEDS'}, {'srcline': 14, 'description': 'MSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'MSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'MSAC'}, {'srcline': 15, 'description': 'RRANSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RRANSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RRANSAC'}, {'srcline': 16, 'description': 'RMSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'RMSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'RMSAC'}, {'srcline': 17, 'description': 'MLESAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'MLESAC', 'ctype': 'std::string', 'type': 'str', 'name': 'MLESAC'}, {'srcline': 18, 'description': 'PROSAC', 'srcfile': '/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg', 'cconsttype': 'const char * const', 'value': 'PROSAC', 'ctype': 'std::string', 'type': 'str', 'name': 'PROSAC'}]}", &TorusFinderConfig::algorithm)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.min_radius = 0.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.min_radius = 5.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.min_radius = 0.1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("min_radius", "double", 0, "minium radius of torus", "", &TorusFinderConfig::min_radius)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("min_radius", "double", 0, "minium radius of torus", "", &TorusFinderConfig::min_radius)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.max_radius = 0.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.max_radius = 5.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.max_radius = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("max_radius", "double", 0, "minium radius of torus", "", &TorusFinderConfig::max_radius)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("max_radius", "double", 0, "minium radius of torus", "", &TorusFinderConfig::max_radius)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.outlier_threshold = 0.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.outlier_threshold = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.outlier_threshold = 0.01;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("outlier_threshold", "double", 0, "outlier threshold", "", &TorusFinderConfig::outlier_threshold)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("outlier_threshold", "double", 0, "outlier threshold", "", &TorusFinderConfig::outlier_threshold)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.max_iterations = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.max_iterations = 10000;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.max_iterations = 100;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<int>("max_iterations", "int", 0, "max iterations", "", &TorusFinderConfig::max_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<int>("max_iterations", "int", 0, "max iterations", "", &TorusFinderConfig::max_iterations)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.min_size = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.min_size = 1000;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.min_size = 10;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<int>("min_size", "int", 0, "minimum number of inliers", "", &TorusFinderConfig::min_size)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<int>("min_size", "int", 0, "minimum number of inliers", "", &TorusFinderConfig::min_size)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.eps_hint_angle = 0.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.eps_hint_angle = 3.14159265359;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.eps_hint_angle = 0.1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("eps_hint_angle", "double", 0, "eps angle for hint", "", &TorusFinderConfig::eps_hint_angle)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("eps_hint_angle", "double", 0, "eps angle for hint", "", &TorusFinderConfig::eps_hint_angle)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.voxel_grid_sampling = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.voxel_grid_sampling = 1;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.voxel_grid_sampling = 0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<bool>("voxel_grid_sampling", "bool", 0, "use voxel grid sampling", "", &TorusFinderConfig::voxel_grid_sampling)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<bool>("voxel_grid_sampling", "bool", 0, "use voxel grid sampling", "", &TorusFinderConfig::voxel_grid_sampling)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __min__.voxel_size = 0.001;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __max__.voxel_size = 1.0;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __default__.voxel_size = 0.02;
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.abstract_parameters.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("voxel_size", "double", 0, "voxel grid size", "", &TorusFinderConfig::voxel_size)));
//#line 290 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __param_descriptions__.push_back(TorusFinderConfig::AbstractParamDescriptionConstPtr(new TorusFinderConfig::ParamDescription<double>("voxel_size", "double", 0, "voxel grid size", "", &TorusFinderConfig::voxel_size)));
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      Default.convertParams();
//#line 245 "/opt/ros/kinetic/lib/python2.7/dist-packages/dynamic_reconfigure/parameter_generator_catkin.py"
      __group_descriptions__.push_back(TorusFinderConfig::AbstractGroupDescriptionConstPtr(new TorusFinderConfig::GroupDescription<TorusFinderConfig::DEFAULT, TorusFinderConfig>(Default)));
//#line 366 "/opt/ros/kinetic/share/dynamic_reconfigure/cmake/../templates/ConfigType.h.template"

      for (std::vector<TorusFinderConfig::AbstractGroupDescriptionConstPtr>::const_iterator i = __group_descriptions__.begin(); i != __group_descriptions__.end(); ++i)
      {
        __description_message__.groups.push_back(**i);
      }
      __max__.__toMessage__(__description_message__.max, __param_descriptions__, __group_descriptions__);
      __min__.__toMessage__(__description_message__.min, __param_descriptions__, __group_descriptions__);
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__, __group_descriptions__);
    }
    std::vector<TorusFinderConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    std::vector<TorusFinderConfig::AbstractGroupDescriptionConstPtr> __group_descriptions__;
    TorusFinderConfig __max__;
    TorusFinderConfig __min__;
    TorusFinderConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;

    static const TorusFinderConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static TorusFinderConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &TorusFinderConfig::__getDescriptionMessage__()
  {
    return __get_statics__()->__description_message__;
  }

  inline const TorusFinderConfig &TorusFinderConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }

  inline const TorusFinderConfig &TorusFinderConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }

  inline const TorusFinderConfig &TorusFinderConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }

  inline const std::vector<TorusFinderConfig::AbstractParamDescriptionConstPtr> &TorusFinderConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const std::vector<TorusFinderConfig::AbstractGroupDescriptionConstPtr> &TorusFinderConfig::__getGroupDescriptions__()
  {
    return __get_statics__()->__group_descriptions__;
  }

  inline const TorusFinderConfigStatics *TorusFinderConfig::__get_statics__()
  {
    const static TorusFinderConfigStatics *statics;

    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = TorusFinderConfigStatics::get_instance();

    return statics;
  }

//#line 12 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_RANSAC = "RANSAC";
//#line 13 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_LMEDS = "LMEDS";
//#line 14 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_MSAC = "MSAC";
//#line 15 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_RRANSAC = "RRANSAC";
//#line 16 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_RMSAC = "RMSAC";
//#line 17 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_MLESAC = "MLESAC";
//#line 18 "/tmp/binarydeb/ros-kinetic-jsk-pcl-ros-1.2.9/cfg/TorusFinder.cfg"
      const char * const TorusFinder_PROSAC = "PROSAC";
}

#undef DYNAMIC_RECONFIGURE_FINAL

#endif // __TORUSFINDERRECONFIGURATOR_H__
